HDU5543-Pick The Sticks

来源:互联网 发布:centos 别名 编辑:程序博客网 时间:2024/06/01 09:40

Pick The Sticks

                                                                     Time Limit: 15000/10000 MS (Java/Others)    Memory Limit: 65535/65535 K (Java/Others)
                                                                                                     Total Submission(s): 1750    Accepted Submission(s): 557


Problem Description
The story happened long long ago. One day, Cao Cao made a special order called "Chicken Rib" to his army. No one got his point and all became very panic. However, Cao Cao himself felt very proud of his interesting idea and enjoyed it.

Xiu Yang, one of the cleverest counselors of Cao Cao, understood the command Rather than keep it to himself, he told the point to the whole army. Cao Cao got very angry at his cleverness and would like to punish Xiu Yang. But how can you punish someone because he's clever? By looking at the chicken rib, he finally got a new idea to punish Xiu Yang.

He told Xiu Yang that as his reward of encrypting the special order, he could take as many gold sticks as possible from his desk. But he could only use one stick as the container.

Formally, we can treat the container stick as an L length segment. And the gold sticks as segments too. There were many gold sticks with different length ai and value vi. Xiu Yang needed to put these gold segments onto the container segment. No gold segment was allowed to be overlapped. Luckily, Xiu Yang came up with a good idea. On the two sides of the container, he could make part of the gold sticks outside the container as long as the center of the gravity of each gold stick was still within the container. This could help him get more valuable gold sticks.

As a result, Xiu Yang took too many gold sticks which made Cao Cao much more angry. Cao Cao killed Xiu Yang before he made himself home. So no one knows how many gold sticks Xiu Yang made it in the container.

Can you help solve the mystery by finding out what's the maximum value of the gold sticks Xiu Yang could have taken?
 

Input
The first line of the input gives the number of test cases, T(1T100)T test cases follow. Each test case start with two integers, N(1N1000) and L(1L2000), represents the number of gold sticks and the length of the container stick. N lines follow. Each line consist of two integers, ai(1ai2000)and vi(1vi109), represents the length and the value of the ith gold stick.
 

Output
For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the maximum value of the gold sticks Xiu Yang could have taken.
 

Sample Input
43 74 12 18 13 74 22 18 43 54 12 28 91 110 3
 

Sample Output
Case #1: 2Case #2: 6Case #3: 11Case #4: 3
Hint
In the third case, assume the container is lay on x-axis from 0 to 5. Xiu Yang could put the second gold stick center at 0 and put the third gold stick center at 5, so none of them will drop and he can get total 2+9=11 value. In the fourth case, Xiu Yang could just put the only gold stick center on any position of [0,1], and he can get the value of 3.
 

Source
The 2015 China Collegiate Programming Contest
 

Recommend
wange2014
 

题意:在一个狭长的容器里面放一些长木棍,每根木棍的长度和价值都不同,现在通过放置木棍使得能够得到的总价值最大。木棍放置不能重叠,对于任意一根木棍,只要他的重心落在容器里面,就算有一部分出去了,也算能够放下。

解题思路:有三种情况:1、0根木棍在外面。2、1根木棍在外面。3、2根木棍在外面。可以考虑多设一个维度。dp[j][k]代表占用长度j时候有k根露在外面的最大价值,然后背包。只把重心放在容器里面把体积的一半放进去,这是会出现小数的,所以我们应该把全部体积乘上2再计算。


#include <iostream>#include <cstdio>#include <cstring>#include <string>#include <algorithm>#include <cmath>#include <map>#include <set>#include <stack>#include <queue>#include <vector>#include <bitset>using namespace std;#define LL long longconst int INF = 0x3f3f3f3f3f;int n, l;LL dp[5000][5];struct node{int l;LL val;}x[3005];int main(){int t, cas = 0;scanf("%d", &t);while (t--){scanf("%d%d", &n, &l);l *= 2;memset(dp, 0, sizeof dp);LL maval = 0;for (int i = 1; i <= n; i++){scanf("%d%lld", &x[i].l, &x[i].val);maval = max(maval, x[i].val);x[i].l *= 2;for (int j = l; j >= x[i].l / 2; j--){for (int k = 0; k<3; k++){if (j - x[i].l >= 0) dp[j][k] = max(dp[j][k], dp[j - x[i].l][k] + x[i].val);if (k&&j - x[i].l / 2 >= 0) dp[j][k] = max(dp[j - x[i].l / 2][k - 1] + x[i].val, dp[j][k]);}}}for (int i = 1; i <= l; i++){for (int j = 0; j<3; j++)maval = max(dp[i][j], maval);}printf("Case #%d: %lld\n", ++cas, maval);}return 0;}

0 0
原创粉丝点击